IncludeFile "window.pbi"

Global MessageID.l
Global ErrorMessageID.l
Declare WindowCallback(Window.l, Message.l, wParam.l, lParam.l)
Declare SetStringManipulationBufferSize(Bytes)



mainHwnd.l=OpenWin()
If mainHwnd
   SetStringManipulationBufferSize(1048576)   ; Optional - Expand the Stringbuffer to allow Mailbodys greater than 64k
   SetWindowTitle(0,eSMTP_GetVersionInfo())
   
   ; Implement the SMTP-Eventhandling
   MessageID.l=eSMTP_GetMessageID()              
   ErrorMessageID.l=eSMTP_GetErrorMessageID()   
   If MessageID.l Or ErrorMessageID.l
      SetWindowCallback(@WindowCallback()) 
   EndIf
   
   
   Repeat
      Select WaitWindowEvent()
         Case #PB_EventCloseWindow
              End
         Case #PB_EventGadget
            Select EventGadgetID()
               Case #CMB_AUTHMODE
                  DisableAuthGadgets() 
                  
               Case #BTN_SEND
                  ClearStatusBar()
                  SetGadgetText(#ED_LOG,"")
                  StatusBarText(#SB,0,"Bytes sent:",#PB_StatusBar_Right)
                  StatusBarText(#SB,2,"Status:",#PB_StatusBar_Right)
                  
                  ; Setup the SMTP-Userlib - 
                  eSMTP_Init(mainHwnd.l,GetGadgetText(#ST_SERVER),Val(GetGadgetText(#ST_PORT)),GetGadgetText(#ST_POPSERVER),Val(GetGadgetText(#ST_POPPORT)),GetGadgetState(#CMB_AUTHMODE), GetGadgetText(#ST_USERNAME),GetGadgetText(#ST_PASSWORD)) 
                  
                  ; Add Attachments to the Mail
                  bytestosend.l=Len(GetGadgetText(#ED_BODY))
                  For i=0 To CountGadgetItems(#LV_ATTACHMENTS)-1
                      file.s=GetGadgetItemText(#LV_ATTACHMENTS,i,0)
                      bytestosend.l+GetBase64Size(file.s)
                      eSMTP_AddAttachment(file.s)
                  Next i
                  SetProgressbarRange(#PB, 0, bytestosend)
                 
                  ; Add CarbonCopy Recipient
                  eSMTP_AddCC(GetGadgetText(#ST_CC))
                  
                  ; Add BlindCarbonCopy Recipient
                  eSMTP_AddBCC(GetGadgetText(#ST_BCC))
                  ;SMTP_AddBCC("Somewhere <somewhere@email.com>")
                  
                  ; Send the Mail
                  success=eSMTP_SendMail(GetGadgetText(#ST_SENDER),GetGadgetText(#ST_RPLTO),GetGadgetText(#ST_TO),GetGadgetText(#ST_SUBJECT),GetGadgetText(#ED_BODY))
                  
                  SetGadgetState(#PB,0)
                  
                  ; Show the Log
                  SetGadgetText(#ED_LOG,eSMTP_GetLog())
                                   
               Case #BTN_ADDFILE
                  file.s=OpenFileRequester("Open File","","All Files|*.*",1) 
                  If file.s
                     AddGadgetItem(#LV_ATTACHMENTS,-1,file.s)
                  EndIf
               Case #BTN_DELETEFILE
                  If GetGadgetState(#LV_ATTACHMENTS)>-1
                     RemoveGadgetItem(#LV_ATTACHMENTS,GetGadgetState(#LV_ATTACHMENTS))
                  EndIf
               Case #BTN_LOAD
                  file.s = OpenFileRequester("Load","","Ini-File|*.ini", 1) 
                  If file.s
                     ReadDefaultValues(file.s)
                  EndIf
               Case #BTN_SAVE 
                  file.s = SaveFileRequester("Save","","Ini-File|*.ini", 1) 
                  If file.s
                     WriteDefaultValues(file.s)
                  EndIf   
            EndSelect
      EndSelect  
   ForEver
EndIf

Procedure SetStringManipulationBufferSize(Bytes) ; Optional - by PB to expand Stringbuffer to allow Strings greater than 64k
  ; taken from the Forum
  PBStringBase.l = 0 
  PBMemoryBase.l = 0 
  !MOV eax, dword [PB_StringBase] 
  !MOV [esp+4],eax 
  !MOV eax, dword [PB_MemoryBase] 
  !MOV [esp+8],eax 
  HeapReAlloc_(PBMemoryBase, #GMEM_ZEROINIT, PBStringBase, Bytes) 
  !MOV dword [_PB_StringBase],eax 
EndProcedure

Procedure WindowCallback(Window.l, Message.l, wParam.l, lParam.l)
  Result.l = #PB_ProcessPureBasicEvents
  Select Message
     Case MessageID.l
        If wParam
           bytes.l=PeekL(wParam)
           StatusBarText(#SB,1,Str(bytes))
           SetGadgetState(#PB,bytes)
        EndIf   
        If lParam
           StatusBarText(#SB,3,PeekS(lParam)) 
        EndIf
     Case ErrorMessageID.l
        If lParam
           MessageRequester("Error",PeekS(lParam))
        EndIf
  EndSelect  
  ProcedureReturn Result
EndProcedure



; ExecutableFormat=Windows
; EnableXP
; Executable=C:\medi-a\Projects\medi-a\_PureBasic\Programme\MyeSMTP\PureSMTPTest.exe
; EOF